#!/usr/bin/perl 

# Comment this next line out (put a # in front of it) if you don't 
# have CGI.pm installed on your server.  Most servers have it, so don't worry.
use CGI::Carp qw(fatalsToBrowser);

# Leave these next three lines alone:
use Text::Wrap;
require "omni_config.cgi";
require "omni_lib.cgi";

# Delete this next 'require' line, if TigerTom's forgotten to!
# require "/user/yourserver/absolute/path_to/cgi-bin/internet-marketing-consultant/contract.cgi";

############################### The Sub-Routine Order #########################
#
# Sub routines in order of their processing your form data. Comment out
# the optional ones you don't want to activate, by putting a # and a space in 
# front of them, like this :
# &cookie;       
# It's a good idea to do this if you feel up to it, as the script will 
# then run faster, and be be less likely to crash!
#
###############################################################################
#   WARNING!: Sub-routines calls marked 'ESSENTIAL' should be left alone!     #
###############################################################################

  &referer_check;     # Optional.  Check only your website is calling this script.
                      # Comment this option out if you are using the affiliate- 
                      # tracking or unsubscribe-from-an-email functions.

 &parse_data;         # ESSENTIAL. Parse the raw form data.

 &get_date;           # ESSENTIAL. Get the time and date. 

 &hack_check;         # ESSENTIAL.

 &send_bulk_mail;     # VERY Optional. To send bulk mail.

 &CC_decrypt;         # Optional. Allow decryption of encrypted credit-card details sent via the form.

 &required_check;     # Optional. Check required fields have been filled in. 

 &email_check;        # Optional. Check basic validity of email address syntax.  

 &cookie_bake;        # Optional. For getting or setting a cookie.

 &VerifyCC;           # Optional. Check basic credit card number validity.

 &save_delimited;     # Optional. Save to database file

 &subscription;       # Optional. Subscribe or unsubscribe to mailing list.

 &shopping_cart;      # Optional. Calculate items' cost.
  
 &your_email;         # Optional. Send an email to the webmaster.

 &their_email;        # Optional. Send an email to the customer.

 &end_url;            # ESSENTIAL. Final script routines.

 exit 0;              # ESSENTIAL. Script action ends.

##############################################################################
# COPYRIGHT NOTICE                                                           #
# TigerTom's OMNI Script. Version: 1.0, April 2001.                          # 
#                                                                            #  
# Copyright 2000 T. O' Donnell.  All Rights Reserved.                        #
# http://www.tigertom.com/contact.htm                                        #
#                                                                            #
# This Perl script may be used and modified free of charge by anyone so      # 
# long as this copyright notice, the comments below, and the advertisement   # 
# it generates remain intact. By using this code you agree to indemnify T. O'#
# Donnell, Inc. and T. O' Donnell from any liability that might arise from   # 
# its use.                                                                   #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.                                                       #
# You must get permission from T. O' Donnell and the other contributors      # 
# before redistributing this software over the Internet or via any           # 
# other medium.                                                              #
# You may not redistribute an altered version of this program in any form,   # 
# via any medium.                                                            # 
#                                                                            #
# In all cases copyright and header must remain intact.                      #
#                                                                            #                    
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United Kingdom Of Great Britain.                 #
#                                                                            #
##############################################################################

########## Only would-be programmers should edit past this point! ########## 

########################### The main sub-routines ###############################

# Get the form input : 

sub parse_data {


# If the data is coming from a direct GET request: 
 if ($ENV{'REQUEST_METHOD'} eq 'GET') {
 $buffer = $ENV{'QUERY_STRING'};

# Check for excessive data:
if (length($buffer) > $legit_length) {&hack_alert;}
         
	} # End if

 
# Otherwise read in form data:
else  { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }

     
    # Split the name-value pairs
    @pairs = split(/&/, $buffer);

		# Check if surfer has already validated his input, and if he has
		# set the scalar so he doesn't have to do it again:

 			if($buffer =~ /confirm_input/i && $buffer !~ /already_confirmed/i) {
  		 	$confirm_input = 1;
			# Start printing a header for the confirmation page, if not begun already
			if(!$header_started) {
  			&start_form_header;
  			$header_started = 1;
         		  } # End if
                      } # End if

       
    foreach $pair (@pairs) {
    
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
      $value =~ s/~!/ ~!/g;

    
       # Neturalise HTML and SSI's [hack attempts], 

	        $value =~ s/\</\&lt\;/g;  # html tag removal (optional)
                $value =~ s/\>/\&gt\;/g;  # html tag removal (optional)
                $value =~ s/\"/&quot\;/g; # Quotation mark substitution


    
  # Uncomment for debugging purposes
  # print "Setting $name to $value<P>";

  $FORM{$name} = $value;

	# If the length of a value/string is greater than that
	# which we've specified, wrap it

 		if (length($FORM{'message'}) > $string_limit) {
		# Wrap long message [large values]
		$Text::Wrap::columns=$wrap_at; # This is the line length for your mail message text.
		$FORM{'message'} = wrap("\t","", $FORM{'message'});
             		} # End if

	# Print out submitted form field as a hidden field
        if($confirm_input) {
        &print_hidden;
                     } # End if
           	
            
   } # End foreach


   $advert = "This email was sent via software available from http://www.tigertom.com.";

 # Output footer page 
 &start_form_footer; 
    
  } # End read parse

###########################

# Send an email :

sub your_email {  

if ($FORM{'Email'} && $FORM{'from_email'}) {

open (MAIL,"|$mailprog -oi -t") || die "Error - cannot open $mailprog: $!\n";
print MAIL ("From: $FORM{'Name'} <$FORM{'Email'}>\n");
print MAIL ("To: $FORM{'Recipient'}\n");
print MAIL ("Reply-To: $FORM{'Email'}\n");
   if ($carbon) {
print MAIL ("Cc: <$carbon>\n");
 }

if ($FORM{'Subject'}) { 
 print MAIL ("Subject: $FORM{'Subject'}\n\n");
   }

 else { print MAIL ("Subject: $subject\n\n");
          }

    
print MAIL ("Dear $FORM{'from_name'}\n\n");

print MAIL ("Here is the data submitted via your web form $ENV{'HTTP_REFERER'} at (server time) $time $date:\n\n");

# If customer has chosen to subscribe to or unsubscribe from mailing list :

if ($FORM{'action'} eq "subscribe") {

  unless (!$duplic) {
        print MAIL "$FORM{'Name'} <$FORM{'Email'}> has tried to make a duplicate\n";
        print MAIL "subscription to the $FORM{'from_name'} mailing list.\n\n";
           }
  unless($duplic) {
  print MAIL "$FORM{'Name'} <$FORM{'Email'}> has been subscribed to\n";
  print MAIL "the $FORM{'from_name'} mailing list.\n\n";
          }
     }

elsif ($FORM{'action'} eq "unsubscribe") {

print MAIL "$FORM{'Name'} <$FORM{'Email'}> has been unsubscribed\n";
print MAIL "from the $FORM{'from_name'} mailing list.\n\n";

 } 


# use PGP, if PGP is set up :

 if ($pgp_public_key_user_id && $pgp_path) {&pgpmail;}

# If not, print form data as-is...

else  {
      unless(!$weak_encrypt) {        
                       &CC_encrypt; 
                          } # End unless

             if (!@secure_print) {
                     @secure_print = split(/,/, $FORM{'secure_print_form_fields'});
                         } # End if

 
  foreach $name(@secure_print) {
                 if($FORM{$name}) {

		# Make the names look more presentable (get rid of '_')
		$cleaned_name = $name;
		$cleaned_name =~ s/_/ /g;

                print MAIL "$cleaned_name : $FORM{$name}\n";
                               }
                          }
                } # End else
        
       # Print shopping cart receipt, if any:
             print MAIL "-" x 65 . "\n";
             &mail_total;
 
# Delete the next line: TigerTom's use only
# &contract;
  
# Print environmental variables. Useful for tracking and identification.

print MAIL "-" x 65 . "\n";
print MAIL "Environmental (server and browser) variables :\n\n";
print MAIL "IP Number     : $ENV{'REMOTE_ADDR'}\n";
print MAIL "Browser       : $ENV{'HTTP_USER_AGENT'}\n";
print MAIL "Proxy         : $ENV{'HTTP_FORWARDED'}\n";
print MAIL "Cookie        : $ENV{'HTTP_COOKIE'}\n";

print MAIL "Time:         : $time $date\n";

close (MAIL);

  }
}

###################

sub their_email {  

if ($FORM{'Email'} && $FORM{'from_email'}) {

 
open (REPLY, "$path_to_data_files/$FORM{'email_text_file'}") || die print "Error - cannot open $path_to_data_files/$FORM{'email_text_file'}: $!\n";
       	@text = <REPLY>;
       	close (REPLY);
open (MAIL,"|$mailprog -oi -t") || die "Error - cannot open $mailprog: $!\n";
print MAIL ("From: $FORM{'from_name'} <$FORM{'from_email'}>\n");
print MAIL ("To: \"$FORM{'Name'}\" <$FORM{'Email'}>\n");
print MAIL ("Reply-To: $FORM{'from_email'}\n");

if ($FORM{'Subject'}) { 
 print MAIL ("Subject: $FORM{'Subject'}\n\n");
   }

 else { print MAIL ("Subject: $subject\n\n");
          }

print MAIL ("Dear $FORM{'Name'}\n\n");


# If customer has chosen to subscribe to or unsubscribe from mailing list :

if ($FORM{'action'} eq "subscribe") {

unless (!$duplic) {
        print MAIL "$FORM{'Name'} <$FORM{'Email'}> has already been subscribed to\n";
        print MAIL "to the $FORM{'from_name'} mailing list.\n\n";
           }
unless($duplic) {

# Get rid of spaces in email address
$FORM{'Email'} =~ s/ //g;

print MAIL "Thank you for subscribing to our mailing list. If you want to\n";
print MAIL "unsubscribe at any time just click on this link:\n\n";
print MAIL "$cgi_url?Email=$FORM{'email'}&action=unsubscribe\n\n";
      }
 } 

elsif ($FORM{'action'} eq "unsubscribe") {

print MAIL "You have been unsubscribed from the $FORM{'from_name'} mailing list. If\n";
print MAIL "you want to re-subscribe at any time you may do so at our website.\n";
print MAIL "Thank you.\n\n";

 } 


# Print their form data in email...
 
print MAIL "Here is the data you submitted. It may be incomplete for security reasons:\n\n";

      # Erase sensitive credit card data
      
     $FORM{'Card_number'} = 0;
     $FORM{'Card_expiry_month'} = 0;
     $FORM{'Card_expiry_year'} = 0;
            
    # print the raw form input, as specified earlier in the script:

     if (!@secure_print) {
        @secure_print = split(/,/, $FORM{'secure_print_form_fields'});
                         } # End if



        foreach $name(@secure_print) {
           if($FORM{$name}) { 
			# Make the names look more presentable (get rid of '_')
			$cleaned_name = $name;
			$cleaned_name =~ s/_/ /g;
                    
           print MAIL "$cleaned_name : $FORM{$name}\n";
                 }
              }

       print MAIL "-" x 65 . "\n";

           # Print shopping cart receipt, if any:
                &mail_total;


print MAIL "\n";
foreach (@text) { print MAIL "$_"; }
# Clear the @text array, to free up memory
@text = 0;

# WEBMASTER: Delete the next line. TigerTom's use only:
# &contract;

print MAIL "\n\n";
print MAIL "-" x 65 . "\n";
print MAIL "\n";

print MAIL "$advert\n";
print MAIL "\n";


# Uuencode and send a zip file with the mail, if specified in the form : 

 if ($zip_dump && ($FORM{'email_zip'} =~ /(\.tar\.gz|\.hqx|\.zip|\.exe)/i)) 
 {&zipmail;}
  
close (MAIL);

  }
}

######################

# Send a mass mail-out:

sub send_bulk_mail {

 if ($FORM{'message'} || $FORM{'bulk_sender'} || $FORM{'mail_subject'}) {

# Stop normal confirmation of input, if set:
$confirm_input = 0;

 print "Content-type: text/html\n\n";
    unless ($path_to_data_files/$FORM{'subscriber_file'}) {
    print "<B>Bulk email error:</B> $path_to_data_files/$FORM{'subscriber_file'} is not defined! <br>\n";
    exit;
    }

unless (-e, "$path_to_data_files/$FORM{'subscriber_file'}") {
    print "<B>Bulk email error:</B> $path_to_data_files/$FORM{'subscriber_file'} does not exist! <br>\n";
    exit;
    }



@necessary = ('password','mail_subject','bulk_sender');
foreach $field(@necessary) {
unless ($FORM{$field}) {
print "<B>Bulk email error: <FONT COLOR=\"#FF0000\">$field</FONT></B> field has not been completed! <br>\n";
exit;
  }
}
 


if ($FORM{'password'} eq "$the_password") {


     print "<B>Opening the subscriber file...</B><BR>\n";
  
open (MAILOUT, "<$path_to_data_files/$FORM{'subscriber_file'}") || die "Error - cannot open $path_to_data_files/$FORM{'subscriber_file'}: $!";
        if($lockit){
        flock(MAILOUT,2);}
	@addresses=<MAILOUT>;
        if($lockit){
        flock(MAILOUT,8);}
	close(MAILOUT);
            print "Got the names and addresses.  Sending the emails....<BR><BR>\n";
   foreach $subscrip(@addresses) {
        chomp($subscrip);
        @entry = split(/$DELIM/, $subscrip);
                  
 # Check if there's a valid email address where the webmaster thinks there's one.
      
         if ($entry[$addr_loc] =~ /.+\@.+\..+/) {
                $addr = $entry[$addr_loc];
                         }

        # Check if there's ONLY an email address in the database entry.  If not, check the $name_loc array field for one.
        elsif(!$entry[$addr_loc] || $entry[$addr_loc] eq "") {
                      $addr = $entry[$name_loc];
                           }
        
         $addr =~ s/[\<\>]//gm;  # remove brackets
         $addr =~ s/\s//gm;  # remove spaces

        
         if ($addr =~ /.+\@.+\..+/) {$continue = 1;}
          
          
    # If neither of the specified database fields has a valid email address, do not proceed
         
          if(!$continue) {print "Field $entry[$addr_loc] at database field number $addr_loc or field $entry[$name_loc] at field number $name_loc,\n";
                          print "do not seem to contain a valid email address.  Mail has not been sent.<BR>\n";
                              }

      unless(!$continue)  {
        $nom = $entry[$name_loc]; 

# Get rid of spaces at beginning of name.
$nom=~ s/^(\s+)//g; 
# Get rid of spaces at end of name.
$nom=~ s/(\s+)$//g;



open (MAIL,"|$mailprog -oi -t") || die "Error - cannot open $mailprog:$!\n";
print MAIL ("From: $FORM{'bulk_sender'}\n");
print MAIL ("To: $addr\n");
print MAIL ("Reply-To: $FORM{'bulk_sender'}\n");
print MAIL ("Subject: $FORM{'mail_subject'}\n\n");
print MAIL "Dear $nom\n\n";
print MAIL "$FORM{'message'}";
print MAIL "\n";
print MAIL "-" x 65 . "\n\n";
print MAIL "Thank you for subscribing to our mailing list. If you want to\n";
print MAIL "unsubscribe at any time just click on this link:\n";
print MAIL "$cgi_url?Email=$addr&action=unsubscribe\n\n";
print MAIL "-" x 65 . "\n\n";
print MAIL "$advert\n";
 close(MAIL);
 print "<B>$nom</B> has been emailed successfully.<br>\n";
    } # End unless
   }  # End foreach (mailout to one subscriber)
print "<B>Bulk mail-out successfully completed.</B>\n";
exit(0);
   } # End all mail-outs (form password OK).
  } # End 'if bulk_mail_out and form message'...
  	 # Clear out the array we've used
   	   @addresses = 0;
 } # End bulk mail out sub-routine

######################

sub zipmail {

# Uuencode the zip file and send it embedded in the email :

open(FILE, "uuencode $zip_dump/$FORM{'email_zip'} $FORM{'email_zip'} |") || die "Error - cannot uuencode $FORM{'email_zip'}: $!";
if($lockit){
flock(FILE,2);}
while (<FILE>) { print MAIL; };
if($lockit){
flock(FILE, 8);}
close(FILE);
 
 }

####################

sub pgpmail {


       if (!@secure_print) {
        @secure_print = split(/,/, $FORM{'secure_print_form_fields'});
                         } # End if

 foreach $name (@secure_print) {
 		if ($FORM{$name}) {
			# Make the names look more presentable (get rid of '_')
			$cleaned_name = $name;
			$cleaned_name =~ s/_/ /g;

 $email_body = "$email_body $cleaned_name : $FORM{$name}\n";
     }
  }  
    
# Next bit of code taken from...
# Application Name: Extropia's WebResponder
# Application Authors: Eric Tachibana (Selena Sol) and Gunther Birznieks
# Version: 5.0

$email_body = &make_pgp_file($email_body,
                  "$pgp_temp_file_path/$$.pgp");

    $email_body = "\n" . $email_body . "\n";

print MAIL "$email_body";


print MAIL "-" x 65 . "\n\n";
     }

###################

# Sub routine to save data into pipe-delimited database format :

sub save_delimited {

    unless($ENV{'QUERY_STRING'}) {

       if(-e, "$path_to_data_files/$FORM{'save_file'}") {
   
          
# Clean up http_referer
$referer = $ENV{'HTTP_REFERER'};
# $referer =~ s/http\:\/\///g;
# $referer =~ s/www\.//g;

  open (DATA, ">>$path_to_data_files/$FORM{'save_file'}") || die "Error - cannot open $path_to_data_files/$FORM{'save_file'}: $!";
       if($lockit){
        flock(DATA,2);}
        print DATA "$time$DELIM2$date$DELIM2$referer$DELIM2$ENV{'REMOTE_ADDR'}$DELIM2$cookie{'ID'}$DELIM2$ENV{'HTTP_COOKIE'}$DELIM2";
        
if (!@insecure_save) {
        @insecure_save = split(/,/, $FORM{'insecure_save_form_fields'});
                         } # End if


foreach $name(@insecure_save) {
              print DATA "$FORM{$name}$DELIM2";
                 }
        print DATA "\n";
        if($lockit){
        flock(DATA,8);}
        close(DATA);
      }
    }
  }

# Subscribe or unsubscribe the customer's email address
# to or from the email database :

sub subscription {
   
        if ($FORM{'action'} eq "subscribe" && $FORM{'Email'} && !$ENV{'QUERY_STRING'} ) {
	open (FILE, "<$path_to_data_files/$FORM{'subscriber_file'}") || die print "Error - cannot open $path_to_data_files/$FORM{'subscriber_file'}: $!";
              if($lockit){
             flock(FILE,2);}
             @list = <FILE>;
              if($lockit){
             flock(FILE,8);}
	     close(FILE);
	        foreach $line(@list) {
		chomp($line);
		if ($line =~ /$FORM{'Email'}/) {
                $duplic = 1;
                     } 
	         }

	        unless($duplic) {
		open (FILE, ">>$path_to_data_files/$FORM{'subscriber_file'}") || die print "Error - cannot open $path_to_data_files/$FORM{'subscriber_file'}: $!";
                         if($lockit){
                        flock(FILE,2);}
		        print FILE "$FORM{'Name'}$DELIM2$FORM{'Email'}\n";
			 if($lockit){
                        flock(FILE,8);}
		        close(FILE);
                    } 
                }
    
    elsif ($FORM{'action'} eq "unsubscribe" && $FORM{'Email'}) {
	
        open (FILE, "$path_to_data_files/$FORM{'subscriber_file'}") || die print "Error - cannot open $path_to_data_files/$FORM{'subscriber_file'}: $!";
             if($lockit){
        		flock(FILE,2);}
       		@list = <FILE>;
	 		if($lockit){
        			flock(FILE,8);}
			close(FILE);
		open (FILE, ">$path_to_data_files/$FORM{'subscriber_file'}") || die print "Error - cannot open $path_to_data_files/$FORM{'subscriber_file'}: $!";
         	        if($lockit){
			flock(FILE,2);}
		foreach $line (@list) {
		chomp($line);
		unless($line =~ /$FORM{'Email'}/) {
			print FILE "$line\n";
		} 
	    }
	 		if($lockit){
        			flock(FILE,8);}
	close(FILE);
          }
      # Delete @list array, to free up memory
        @list = 0;
 }


######################

# Cookie get or set :

sub cookie_bake {

# Retrieve any of our cookies already in the browser :

&get_cookie;

# Set a cookie with the name of 'ID'. The value $FORM{'ID'} is got from the
# query_string (see Cookie setup section at the start of this script) :

if($FORM{'ID'}) {
&setCookie("ID", $FORM{'ID'}, $expires, $path, $domain, $secure);
    }  

 }
    


######### Weak encryption of credit-card number and expiry date ##############

sub CC_encrypt {


unless($encrypted) {
         
   for(keys(%cc_encrypt)){ 
          $FORM{'Card_number'} =~ s/$_/   $cc_encrypt{$_}/g;
          $FORM{'Card_number'} =~ s/[ \t-]//g; # remove white spaces etc.

                   }

for(keys(%date_encrypt)){
	$FORM{'Card_expiry_month'} =~ s/$_/   $date_encrypt{$_}/g;
        $FORM{'Card_expiry_year'} =~ s/$_/   $date_encrypt{$_}/g;
        $FORM{'Card_expiry_month'} =~ s/[ \t-]//g; # remove white spaces etc.
        $FORM{'Card_expiry_year'} =~ s/[ \t-]//g; # remove white spaces etc.


          }
       
        } # End unless

   # Make a note, so we don't do it again:
     $encrypted = 1;
     
     } # End CC encrypt


######### Decrypt credit-card number and expiry year #######

sub CC_decrypt {

  
 if($FORM{'Card_number'} && $FORM{'Card_expiry_month'} && $FORM{'Card_expiry_year'} && $FORM{'password'} eq $the_password) {

   for(keys(%cc_decrypt)){ 
          $FORM{'Card_number'} =~ s/$_/   $cc_decrypt{$_}/g;
          $FORM{'Card_number'} =~ s/[ \t-]//g;  # remove white spaces etc.
                   }
    for(keys(%date_decrypt)){         
	$FORM{'Card_expiry_month'} =~ s/$_/   $date_decrypt{$_}/g;
        $FORM{'Card_expiry_year'} =~ s/$_/   $date_decrypt{$_}/g;
        $FORM{'Card_expiry_month'} =~ s/[ \t-]//g; # remove white spaces etc.
        $FORM{'Card_expiry_year'} =~ s/[ \t-]//g; # remove white spaces etc.

          }
    print "Content-type: text/html\n\n"; 
    print "Card Number is <B>$FORM{'Card_number'}</B><BR>\n";
    print "Card Expiry Month is <B>$FORM{'Card_expiry_month'}</B><BR>\n";
    print "Card Expiry Year is <B>$FORM{'Card_expiry_year'}</B><BR>\n";
    exit(0);  
  
   } # End if
      
 } # End CC decrypt


################## Print a shopping cart receipt

sub html_total {  
 

     # If an actual purchase has occurred, proceed:
#       unless($subtotal = '0.00') { 

		# Put in the 'shelf_array' form field into an array
				if(!@shelf){
	  @shelf = split(/,/, $FORM{'shelf_array'});
				}

 # Print out the receipt headings:
     
  print << "EOF";

<TABLE WIDTH="95%" CELLPADDING="2" CELLSPACING="0" BORDER="0">
<TR><TD WIDTH="20%" VALIGN="LEFT"><P><B><FONT FACE="Verdana,Arial" SIZE="2">ITEM:</FONT></B></TD><TD WIDTH="20%" VALIGN="RIGHT"><B><DIV ALIGN="RIGHT"><FONT FACE="Verdana,Arial" SIZE="2">PRICE $FORM{'currency'}:</FONT></DIV></B><P></TD><TD WIDTH="20%" VALIGN="RIGHT"><B><DIV ALIGN="RIGHT"><FONT FACE="Verdana,Arial" SIZE="2">QUANTITY:</FONT></DIV></B><P></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><B><DIV ALIGN="RIGHT"><FONT FACE="Verdana,Arial" SIZE="2">COST $FORM{'currency'}:</FONT></DIV></B></TD></TR>
</TABLE>

EOF
  

    # Print out the receipt via a clever manipulation of the @shelf array:

$location = 0;

      foreach $item(@shelf) {
                 while ($location <= $#shelf) {
		
	 	 # Calculate original number of each item ordered 
                  # (by dividing the cost of each item by its price):

                                     # Make sure we don't try to divide by 0
                          		unless(!$FORM{$shelf[$location + 1]} || !$FORM{$shelf[$location + 2]}) {
                     $location_num_orig = ($FORM{$shelf[$location + 1]} / $FORM{$shelf[$location + 2]});
                                   		

           # And print out each item name, price, number of items ordered, and cost, unless, the number of
           # items, for an item, is 0:
      

 	print << "EOF";

<TABLE WIDTH="95%" CELLPADDING="2" CELLSPACING="0" BORDER="0">
<TR><TD WIDTH="20%" VALIGN="LEFT"><P><B><DIV ALIGN="LEFT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$FORM{$shelf[$location]}:</FONT></DIV></B></TD><TD WIDTH="20%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$FORM{$shelf[$location + 2]}</FONT></DIV></TD><TD WIDTH="20%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">($location_num_orig)</FONT></DIV></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$FORM{$shelf[$location + 1]}</FONT></DIV></TD></TR>
</TABLE>

EOF
             } # End unless
 
    $location = $location + 3;
      }   
  }


    # Print shipping, tax and total charged:

	print << "EOF";

<HR>
<TABLE WIDTH="95%" CELLPADDING="2" CELLSPACING="0" BORDER="0">
<TR><TR><TD WIDTH="20%" VALIGN=LEFT><P><B><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">Subtotal:</B></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$subtotal</FONT></DIV></TD></TR>
<TR><TD WIDTH="20%" VALIGN=LEFT><P><B><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">Taxation:</B></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$taxation</FONT></DIV></TD></TR> 
<TR><TD WIDTH="20%" VALIGN=LEFT><P><B><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">Shipping:</B></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="20%" VALIGN="RIGHT"><P></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$FORM{'shipping'}</FONT></DIV></TD></TR> 
</TABLE>
<HR>
<TABLE WIDTH="95%" CELLPADDING="2" CELLSPACING="0" BORDER="0">
<TR><TR><TD WIDTH="20%" VALIGN=LEFT><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><P><B><I>Total:</I></B></FONT></TD><TD WIDTH="20%" VALIGN=TOP><P></TD><TD WIDTH="20%" VALIGN=TOP><P></TD><TD WIDTH="12%" VALIGN="RIGHT"><P><B><I><DIV ALIGN="RIGHT"><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$FORM{'currency'}$total</FONT></I></B></DIV></TD></TR> 


EOF
 
 print "</TABLE><BR></FONT>\n"; 
    
 #          } # End unless subtotal
       }


########### Shopping cart total for our emails

sub mail_total {  
   
    # If a cash sale has been made, proceed
#     unless($subtotal = '0.00') { 


	# Put in the 'shelf_array' form field into an array
                            if(!@shelf) {
			  @shelf = split(/,/, $FORM{'shelf_array'});
                                 }
           # Print out the receipt via a clever manipulation of the @shelf array:
                $location = 0;

           foreach $item(@shelf) {
                while ($location <= $#shelf) {
                    
                  # Unless it's already been done, re-calculate original number of each item ordered 
                  # (by dividing the total cost of each item ordered, by its price):
				
				# Make sure we don't try to divide by 0
	        	          unless(!$FORM{$shelf[$location + 1]} || !$FORM{$shelf[$location + 2]}) {
                     $location_num_orig = ($FORM{$shelf[$location + 1]} / $FORM{$shelf[$location + 2]});
                           		 
                       
                   # And print out each item name, price, number of items ordered, and cost, unless the number of items
                   # ordered, of an item, is 0:
     
         print MAIL "Item name: $FORM{$shelf[$location]}.\n";
         print MAIL "Price: $FORM{'currency'}$FORM{$shelf[$location + 2]}.\n"; 
         print MAIL "Quantity ordered: $location_num_orig.\n"; 
         print MAIL "Cost: $FORM{'currency'}$FORM{$shelf[$location + 1]}.\n\n";
         print MAIL "-" x 65 . "\n";
                     } # End unless
          $location = $location + 3;
       }   
    }



    # Print shipping, tax and total charged:

print MAIL "Subtotal: $FORM{'currency'}$subtotal\n";
print MAIL "Taxation: $FORM{'currency'}$taxation\n"; 
print MAIL "Shipping: $FORM{'currency'}$FORM{'shipping'}\n"; 
print MAIL "=" x 65 . "\n";
print MAIL "TOTAL: $FORM{'currency'}$total\n";


   
#           } # End unless subtotal
       } # End sub

########################

   sub shopping_cart {

# Put in the 'shelf_array' form field into an array
@shelf = split(/,/, $FORM{'shelf_array'});

# Set array counter and current order total values
$location = 0;
$subtotal = 0;

              foreach $item(@shelf) {   		
		
            # Multiply, for each item, the number of items ordered, by the price:         
               while ($location <= $#shelf) {
		
                # NOTE: Here's the clever bit; the form 'number of items ordered' variable
                # becomes the total cost of the number of that item ordered (number of items X the price).
	               
                     unless(!$FORM{$shelf[$location + 1]} || !$FORM{$shelf[$location + 2]}) {
                 $FORM{$shelf[$location + 1]} = ($FORM{$shelf[$location + 1]} * $FORM{$shelf[$location + 2]});
 
                       # Convert cost to two decimal places:
                             $FORM{$shelf[$location + 1]} = sprintf("%.2f", $FORM{$shelf[$location + 1]});
						} # End unless
			# Jump to the next item/price pair: 
                             $location = $location + 3; 
                        } # End while
                   } # End foreach

	  # Each item now being a 'multiplicant' cost, calculate the subtotal of the items (add them up) :

		# Re-set array location scalar	
			$location = 0;
             
          foreach $item(@shelf) {

             while ($location <= $#shelf) { 
			unless(!$FORM{$shelf[$location + 1]} || !$FORM{$shelf[$location + 2]}) {
                               $subtotal = ( $subtotal + ($FORM{$shelf[$location + 1]} + $FORM{$shelf[$location + 4]}) );
                 				} # End unless
			 $location = $location + 6; 
                        } # End while
                   
                } # End foreach
         
         # Add tax and shipping:     
       $taxation = 0.00;
	
       if($FORM{'tax'}) { 
        $taxation = ($subtotal * $FORM{'tax'});
             }
    $total = ($subtotal + $taxation + $FORM{'shipping'});
    # Round our values down to two decimal places.
    $taxation = sprintf("%.2f", $taxation);
    $subtotal = sprintf("%.2f", $subtotal);
    $total = sprintf("%.2f", $total);

         } # End shop cart routine     
        


################ Final URls to present to browser:

sub end_url {

# Re-direct browser to FILE to download, if requested:

    if ($FORM{'download_url'} && $FORM{'download'} && $FORM{'download'} ne "on") {
    print "Location: $FORM{'download_url'}\/$FORM{'download'}\n\n";
    exit(0);
  }

# Second SCRIPT URL to send raw data to, if defined in the set-up section:

    elsif ($FORM{'second_script_url'}) {
         print "Location: $FORM{'second_script_url'}\?$buffer\n\n";
         exit(0);
   }

# Redirect browser to thank-you page, if defined in the set-up section:

   elsif ($FORM{'thanks_url'}) {
         print "Location: $FORM{'thanks_url'}\n\n";
         exit(0);
        }

# Or else print a default list of data submitted by the customer :

elsif ($FORM{'Card_number'} || $total) {&print_order_receipt;}

# Else print default output
else {
unless ($header_set) {
print "Content-type: text/html\n\n";
        } # End unless    
print "<h3>The form information has been sent.</h3>\n";
exit(0);
   } # End else

} # End sub
 
   


################
# Start the print-out of the raw form data as hidden fields, 
# so the customer can confirm it:

sub start_form_header {

  &Header;
  print "<FORM ACTION=\"$cgi_url\" METHOD=\"POST\"><BR>\n";
   print "<INPUT TYPE=HIDDEN NAME=\"already_confirmed\" VALUE=\"1\">\n";
              
        } # End sub


####################

sub print_hidden {

 

 print "<INPUT TYPE=HIDDEN NAME=\"$name\" VALUE=\"$FORM{$name}\">\n";
    
    
        } # End sub

####################
 
sub start_form_footer {

if ($confirm_input) {

print "<FONT FACE=\"Verdana,Arial\" SIZE=\"2\">\n";
print "<CENTER><h2>Please confirm your order is correct:</h2></CENTER><br>\n";
print "Here are the details you've submitted.  If they are not correct, please use\n";
print "your browser's <B>back</B> button, and correct them. If they are correct, click on the <B>submit</B> button below.<BR><BR></FONT>\n";

print "<TABLE WIDTH=\"95%\" CELLPADDING=\"2\" CELLSPACING=\"0\" BORDER=\"0\"><TR>\n";


 if (!@secure_print) {
        @secure_print = split(/,/, $FORM{'secure_print_form_fields'});
                         } # End if


foreach $name(@secure_print) {
     if($FORM{$name}) {

# Make the names look more presentable (get rid of '_')
$cleaned_name = $name;
$cleaned_name =~ s/_/ /g;


print "<TR><TD WIDTH=\"20%\" VALIGN=TOP><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><B>$cleaned_name</B></FONT></TD><TD WIDTH=\"30%\" VALIGN=TOP><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><P>$FORM{$name}.</FONT></TD></TR>\n";
         } # End if
       } # End foreach

print "</TABLE>\n";
print "<TABLE WIDTH=\"95%\" CELLPADDING=\"2\" CELLSPACING=\"0\" BORDER=\"0\"><TR>\n";

# Put in the 'shelf_array' form field into an array
 @shelf = split(/,/, $FORM{'shelf_array'});

# Print out the items ordered
if(@shelf) {

print "<HR ALIGN=LEFT>\n";

print "<FONT FACE=\"Verdana,Arial\">\n";
print "<H3 ALIGN=LEFT>Items Ordered:</H3></FONT>\n";

# Start the counter
$location = 0;

while($location <= $#shelf) {

			unless(!$FORM{$shelf[$location + 1]} || !$FORM{$shelf[$location + 2]}) {
 print "<TR><TD WIDTH=\"20%\" VALIGN=TOP><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><B>$FORM{$shelf[$location]}.</B></FONT></TD><TD WIDTH=\"30%\" VALIGN=TOP><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><P>Cost per item:<B>$FORM{'currency'}$FORM{$shelf[$location + 2]}.</B> Quantity ordered: <B>$FORM{$shelf[$location + 1]}.</B><BR></FONT></FONT></TD></TR>\n";
                     } # End unless
              $location = $location + 3;
              } # End while

       } # 
                  
 print "</TABLE><BR><BR>\n";
 print "<HR ALIGN=LEFT>\n";
 print "<INPUT TYPE=SUBMIT VALUE=\"Submit Order Now\"><BR><BR><BR>\n";
 print "<FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><FONT SIZE=\"1\">Software by <a href=\"http:\/\/www.tigertom.com\/index.htm\"><b>TigerTom</b></a></FONT></FONT><br>\n";
 &Footer;
exit(0);

       } # End if to-be-confirmed

 } # End sub start form footer



################## Print out the raw form data so the customer can see it:

sub print_order_receipt {

 # Erase sensitive credit card data
      
     $FORM{'Card_number'} = 0;
     

 unless ($FORM{'bulk_sender'} || $FORM{'password'}) {
      # If we've not already started printing a header, do so
      if(!$confirm_input) {
      &Header;
         } # End if

	 print "<FONT FACE=\"Verdana,Arial\" SIZE=\"2\">\n";
          print "<CENTER><h3>Data submitted to this site:</h3></CENTER><BR>\n";
 print "Some data may be omitted for security reasons.<BR><BR>\n";


if (!@secure_print) {
        @secure_print = split(/,/, $FORM{'secure_print_form_fields'});
                         } # End if

 foreach $name(@secure_print) {
 
 if ($FORM{$name}) {

# Make the names look more presentable (get rid of '_')
$cleaned_name = $name;
$cleaned_name =~ s/_/ /g;
 
	print << "EOF";
<TABLE WIDTH="95%" CELLPADDING="2" CELLSPACING="0" BORDER="0">
<TR><TD WIDTH="35%" VALIGN=TOP><P><B><FONT FACE=\"Verdana,Arial\" SIZE=\"2\">$cleaned_name:</B></FONT></TD><TD WIDTH="55%" VALIGN=TOP><FONT FACE=\"Verdana,Arial\" SIZE=\"2\"><P>$FORM{$name}</FONT></TD></TR>
</TABLE>

EOF
  
	      }
      }
print"<HR>\n";


    # Print shopping cart receipt:
      &html_total;

} # End unless

 print "<FONT FACE=\"Verdana,Arial\" SIZE=\"2\">\n";

      # subscription messages, if necessary:
         if ($duplic) { 
          print "<BR>Your email address has already been subscribed to our mailing list.  There is\n";
           print "no need to re-subscribe.<BR>\n";
            }
        elsif($FORM{'Email'} && $FORM{'action'} eq "subscribe") {
           print "<BR>You have been subscribed to our mailing list. Thank you.<BR>\n";
                 }
        elsif($FORM{'Email'} && $FORM{'action'} eq "unsubscribe") {
           print "<BR>You have been unsubscribed from our mailing list. Thank you.<BR>\n";
                }

 print "<br><b>You may want to save or print this information for your records.</b><br><br>\n\n";
 print "<i>Thank you, from $FORM{'from_name'}.</i><BR><BR>\n\n";
 print "<BR><HR><BR><BR>\n";
 print "<CENTER><FONT SIZE=\"1\">Form processing script available from: "; 
 print "<a href=\"http:\/\/www.tigertom.com\/index.htm\"><b>T. O' Donnell Incorporated.</b></a></FONT></CENTER><br></FONT></FONT>\n";
 &Footer;

 }


